/*
 * Lesen und Schreiben eines externen EEPROMs 24C02 per I2C (STM32)
 * oder des internen EEPROMS (AVR)
 *
 * Created: 02.02.2014
 *  Author: Nicolas
 */ 

#ifndef EEPROM_24CX_H
  #define EEPROM_24CX_H

  #define EEPROM_I2C_DEVICE I2C1
  #define EEPROM_I2C_ADDRESS 0xA0

  #define EEPROM_SIZE_BYTES 128

  enum {ee_ok,
    ee_invalidAddress,
    ee_noStart,
    ee_invalidSize,
    ee_memoryError
  };

  uint_fast8_t eeprom_read_byte(uint8_t addr, uint8_t *byte);
  uint_fast8_t eeprom_write_byte(uint8_t addr, uint8_t byte);
  uint_fast8_t eeprom_read_block(uint8_t *buffer,uint8_t addr,uint8_t size);
  uint_fast8_t eeprom_write_block(uint8_t *buffer,uint8_t addr,uint8_t size);
  uint_fast8_t eeprom_update_block(uint8_t *buffer,uint8_t addr,uint8_t size);

#endif
