/*
 * I2C (polling-Modus) fuer STM32F10x
 * nach Application Note AN2824
 * Beruecksichtigt Hardwarefehler im I2C-Modul
 *
 * Timeouts benoetigen externen Timer uint_least24_t glu_millis
 *
 * Die CMSIS-Structs koennen wegen des Hardwarefehlers nicht verwendet werden,
 * deshalb muessen die Hardware-Adressen direkt hinterlegt werden.
 *
 * Erzeugt: 31.03.2014
 *  Author: Nicolas
 */


#ifndef I2C_STM32F10X_H
  #define I2C_STM32F10X_H
  

  #include "i2c_generic.h"

  #define DISABLE_I2C_ERROR_IRQ

  uint_fast8_t I2C_Sendbuffer(I2C_TypeDef *I2Cx, uint8_t slaveaddr,
		uint8_t* pBuffer, uint8_t nByte, enum stopbit_e stopbit);

  uint_fast8_t I2C_Receivebuffer(I2C_TypeDef *I2Cx, uint8_t slaveaddr,
  		uint8_t* pBuffer, uint8_t nByte);


#endif
